#include <types.h>
#include <system_def.h>
#include <sim.h>
#include <qsm.h>
#include <periph/qsm_rs232.h>
#include <qadc.h>
#include <ctm4.h>
#include <tpu.h>
#include <periph/chmod_lcd.h>
#include <periph/kl41_lcd.h>
#include <string.h>
#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <boot/flashprog.h>
#include <utils.h>
#include <system_sup.h>
#include <cmd_proc.h>


extern int ctm4_time_init();
extern unsigned ctm4_sfi_spmax;
extern int can_hw_init(int baud, int mode);
extern int can_hw_test(char *s);
int tpu_irc_read(int chan);
int tpu_irc_init(int chan);

/*
 *-----------------------------------------------------------
 */

#define WITH_RTC64613
//define WITH_RTC7242

#ifdef WITH_RTC7242

volatile char *rtc7242_addr=(char*)0xf08000;
char date[20]="2000-01-06 16:41:00";


extern __u8 __rtc7242_read_byte_sb;
extern __u8 __rtc7242_read_byte_se;
__u8 *__rtc7242_read_byte_sm=(__u8*)0xFFD000;

__asm__ (
	".text\n"
	".even\n"
	"__rtc7242_read_byte_sb:\n"
	"	nop\n"
	"	moveb	%a0@,%d0\n"
	"	nop\n"
	"	rts\n"
	"__rtc7242_write_byte_sb:\n"
	"	nop\n"
	"	moveb	%d0,%a0@\n"
	"	nop\n"
	"	rts\n"
	"__rtc7242_read_byte_se:\n"
	);


#define __rtc7242_read_byte_si() \
	{ memmove(__rtc7242_read_byte_sm,&__rtc7242_read_byte_sb, \
	  &__rtc7242_read_byte_se-&__rtc7242_read_byte_sb); \
	}

#define __rtc7242_read_byte_sc(addr) \
	({ __u8 val; \
	  __asm__ __volatile__ ( \
	     "	movel	%1,%%a0\n" \
	     "	movel	__rtc7242_read_byte_sm,%%a1\n" \
	     "	jsr	%%a1@\n" \
	     "	moveb	%%d0,%0\n" \
	    :"=d"(val):"r"(addr):"d0","a0","a1","cc" \
	  ); val; \
	})

#define __rtc7242_write_byte_sc(addr,valin) \
	({ __u8 val=valin; \
	  __asm__ __volatile__ ( \
	     "	movel	%1,%%a0\n" \
	     "	moveb	%0,%%d0\n" \
	     "	movel	__rtc7242_read_byte_sm,%%a1\n" \
	     "	jsr	%%a1@(__rtc7242_write_byte_sb-__rtc7242_read_byte_sb)\n" \
	    ::"d"(val),"r"(addr):"d0","a0","a1","cc" \
	  ); val; \
	})

void get_date()
{
  __rtc7242_read_byte_si();
  __rtc7242_write_byte_sc(rtc7242_addr+0xd,3);
  while(__rtc7242_read_byte_sc(rtc7242_addr+0xd)&2)
  {
    __rtc7242_write_byte_sc(rtc7242_addr+0xd,2);
    __rtc7242_write_byte_sc(rtc7242_addr+0xd,3);
  }
  
  date[0]='2';
  date[1]='0';
  date[2]='0'+(__rtc7242_read_byte_sc(rtc7242_addr+0xb)&0xf);
  date[3]='0'+(__rtc7242_read_byte_sc(rtc7242_addr+0xa)&0xf);
  date[4]='-';
  date[5]='0'+(__rtc7242_read_byte_sc(rtc7242_addr+0x9)&0xf);
  date[6]='0'+(__rtc7242_read_byte_sc(rtc7242_addr+0x8)&0xf);
  date[7]='-';
  date[8]='0'+(__rtc7242_read_byte_sc(rtc7242_addr+0x7)&0xf);
  date[9]='0'+(__rtc7242_read_byte_sc(rtc7242_addr+0x6)&0xf);
  date[10]=' ';
  date[11]='0'+(__rtc7242_read_byte_sc(rtc7242_addr+0x5)&0x3);
  date[12]='0'+(__rtc7242_read_byte_sc(rtc7242_addr+0x4)&0xf);
  date[13]=':';
  date[14]='0'+(__rtc7242_read_byte_sc(rtc7242_addr+0x3)&0xf);
  date[15]='0'+(__rtc7242_read_byte_sc(rtc7242_addr+0x2)&0xf);
  date[16]=':';
  date[17]='0'+(__rtc7242_read_byte_sc(rtc7242_addr+0x1)&0xf);
  date[18]='0'+(__rtc7242_read_byte_sc(rtc7242_addr+0x0)&0xf);
  date[19]=0;
  __rtc7242_write_byte_sc(rtc7242_addr+0xd,2);
}

void set_date()
{
  date[4]=0x34; /* value written into reg F, select 24h mode */
  __rtc7242_read_byte_si();
  __rtc7242_write_byte_sc(rtc7242_addr+0xf,date[7]);
  __rtc7242_write_byte_sc(rtc7242_addr+0xb,date[2]);
  __rtc7242_write_byte_sc(rtc7242_addr+0xa,date[3]);
  __rtc7242_write_byte_sc(rtc7242_addr+0x9,date[5]);
  __rtc7242_write_byte_sc(rtc7242_addr+0x8,date[6]);
  __rtc7242_write_byte_sc(rtc7242_addr+0x7,date[8]);
  __rtc7242_write_byte_sc(rtc7242_addr+0x6,date[9]);
  __rtc7242_write_byte_sc(rtc7242_addr+0x5,date[11]);
  __rtc7242_write_byte_sc(rtc7242_addr+0x4,date[12]);
  __rtc7242_write_byte_sc(rtc7242_addr+0x3,date[14]);
  __rtc7242_write_byte_sc(rtc7242_addr+0x2,date[15]);
  __rtc7242_write_byte_sc(rtc7242_addr+0x1,date[17]);
  __rtc7242_write_byte_sc(rtc7242_addr+0x0,date[18]);
  __rtc7242_write_byte_sc(rtc7242_addr+0xf,date[4]);
}


#endif /* WITH_RTC7242 */

#ifdef WITH_RTC64613
volatile char *rtc64613_addr=(char*)0xf08000;
char date[20]="2000-01-06 16:41:00";

void get_date()
{
  int lpcnt;
  __u8 b;
  __u8 creg_a;  
  creg_a=rtc64613_addr[1];
  lpcnt=5;
  do{
    rtc64613_addr[1]=creg_a&~0x80;
    date[0]='2';
    date[1]='0';
    b=rtc64613_addr[7];	/* year */
    date[2]='0'+((b>>4)&0xf);
    date[3]='0'+(b&0xf);
    date[4]='-';
    b=rtc64613_addr[6];	/* month */
    date[5]='0'+((b>>4)&0x1);
    date[6]='0'+(b&0xf);
    date[7]='-';
    b=rtc64613_addr[5];	/* day */
    date[8]='0'+((b>>4)&0x3);
    date[9]='0'+(b&0xf);
    date[10]=' ';
    b=rtc64613_addr[3];	/* hour */
    date[11]='0'+((b>>4)&0x3);
    date[12]='0'+(b&0xf);
    date[13]=':';
    b=rtc64613_addr[2];	/* minute */
    date[14]='0'+((b>>4)&0x7);
    date[15]='0'+(b&0xf);
    date[16]=':';
    b=rtc64613_addr[1];	/* second */
    date[17]='0'+((b>>4)&0x7);
    date[18]='0'+(b&0xf);
    date[19]=0;
  }while(((creg_a=rtc64613_addr[1])&0x80)&&lpcnt--);
}

void set_date()
{
  __u8 b;

  rtc64613_addr[15]=0;
  
  b=(date[2]-'0')<<4;
  b|=date[3]-'0';
  rtc64613_addr[7]=b;	/* year */
  b=(date[5]-'0')<<4;
  b|=date[6]-'0';
  rtc64613_addr[6]=b;	/* month */
  b=(date[8]-'0')<<4;
  b|=date[9]-'0';
  rtc64613_addr[5]=b;	/* day */
  b=(date[11]-'0')<<4;
  b|=date[12]-'0';
  rtc64613_addr[3]=b;	/* hour */
  b=(date[14]-'0')<<4;
  b|=date[15]-'0';
  rtc64613_addr[2]=b;	/* minute */
  b=(date[17]-'0')<<4;
  b|=date[18]-'0';
  rtc64613_addr[1]=b;	/* second */

  rtc64613_addr[15]=1;
}

#endif /* WITH_RTC64613 */

/*
 *-----------------------------------------------------------
 */

/* QADC system */

short qadc_bq2;

int qadc_init_16ch()
{
  int i;
  int loc;
  *QADC_QACR1=0;
  *QADC_QACR2=0;

  qadc_bq2=10;
  *QADC_MCR=ISR_QADC_IARB;
  *QADC_INT=0;
  /* *QADC_DDRQA=0x00; */

  /* 1MHz QCLK (16+5) for 21MHz fsys, no mux */ 
  *QADC_QACR0=__val2mfld(QADC_MUX,0)|__val2mfld(QADC_PSH,15)|
              __val2mfld(QADC_PSA,0)|__val2mfld(QADC_PSL,4);

  loc=qadc_bq2;
  /* conversion of ADC0(PQB0) to ADC15(PQA7), Vrl and Vrh */
  for(i=0;i<18;i++,loc++){
    QADC_CCW[loc]=__val2mfld(QADC_P,0)|
                  __val2mfld(QADC_BYP,0)|
                  __val2mfld(QADC_IST,1)|
                  __val2mfld(QADC_CHAN,i<4?i:i+44);
  }
  QADC_CCW[loc]=__val2mfld(QADC_CHAN,63);
  
  /* queue 2 software triggered continuous-scan mode */
  *QADC_QACR2=__val2mfld(QADC_MQ2,17)|QADC_RES|
              __val2mfld(QADC_BQ2,qadc_bq2);

  return 0;
};


/* Basic SPI mode settings */

int qspi_ffree_loc;	/* first free QSPI loaction */

int qspi_mode_init()
{
  *QSM_PORTQS=0xfb;	/* SCK inactive is L, rest H */
  *QSM_DDRQS= 0xfe;	/* MISO is input, rest output */
  *QSM_PQSPAR=0xff;	/* all pins have QSPI function */

  /* master, variable length 16 bits, 500 kBd for fsys 21 MHZ */
  *QSM_SPCR0=QSM_MSTR|__val2mfld(QSM_BITS,16)|
             __val2mfld(QSM_SPBR,21);

  /* delay first clock 1us after PCSx, delay after transfer 1.5us */
  *QSM_SPCR1=__val2mfld(QSM_DSCKL,21)|__val2mfld(QSM_DTL,1);

  /* interrupt disabled, after finish wrap to NEWQP */
  *QSM_SPCR2=QSM_SPIFIE*0|QSM_WREN*1|QSM_WRTO*1|
             __val2mfld(QSM_ENDQP,0)|__val2mfld(QSM_NEWQP,0);

  *QSM_SPCR3=QSM_HMIE*0|QSM_HALT*0;
  *QSM_SPSR=0;
  
  qspi_ffree_loc=0;	/* no transfer location is allocated */
  
  return 0;
}


/* Current sensing ADC on SPI - TLC0838 */

short tlcadc_qspi_loc;

int tlcadc_init()
{
  int i;
  int loc;

  atomic_clear_mask_w(QSM_SPE,QSM_SPCR1);
  loc=qspi_ffree_loc;
  tlcadc_qspi_loc=loc;
  for(i=7;i>=0;i--,loc++){
    /* SPCR0 defined bit count, SPCR1 defined delay after transfer
       and delay after PCS, TLC0838 connected to PCS0 */
    QSM_QSPICR[loc]=QSM_CONT*0|QSM_BITSE*1|QSM_DT*1|QSM_DSCK*1|
                    __val2mfld(QSM_PCS,~1);

    /* TLC0838 command */
    /* StartBit SGL/DIFF SEL1 SEL0 */
    QSM_QSPITR[loc]=(1<<15)|(1<<14)|((i&1)<<13)|((i>>1)<<11);
  }

  qspi_ffree_loc=loc;
  *QSM_SPCR2=(*QSM_SPCR2&~QSM_ENDQP)|__val2mfld(QSM_ENDQP,loc-1);
  atomic_set_mask_w(QSM_SPE,QSM_SPCR1);
  return 0;
}

int tlcadc_read(int i)
{
  return (QSM_QSPIRR[tlcadc_qspi_loc+i]>>2)&0xff;
  //return QSM_QSPIRR[tlcadc_qspi_loc+i];
}


/* Led indicators and power control panel on SPI */

/* bit 2  .. ERR	*/
/* bit 3  .. BSY	*/
/* bit 4  .. S2		*/
/* bit 5  .. S1		*/
/* bit 8  .. mot A	*/
/* ...			*/
/* bit 15 .. mot H	*/

#define QSPI_LED_MSK_ARM     0x0001
#define QSPI_LED_MSK_STOP    0x0002
#define QSPI_LED_MSK_ERR     0x0004
#define QSPI_LED_MSK_BSY     0x0008
#define QSPI_LED_MSK_S2      0x0010
#define QSPI_LED_MSK_S1      0x0020
#define QSPI_LED_MSK_A       0x0100

/* Power status and switches */

#define QSPI_LED_PRESENT_L   0x0010
#define QSPI_LED_SWITCH_ARM  0x0100
#define QSPI_LED_SWITCH_STOP 0x0200
#define QSPI_LED_PWR_SENSE   0x0400
#define QSPI_LED_PRESENT_H   0x1000

short qspi_led_qspi_loc;

int qspi_led_init()
{
  int loc;
  int pcs_mask;

  pcs_mask=~2; /* LED indicators at PCS2 non */

  atomic_clear_mask_w(QSM_SPE,QSM_SPCR1);
  loc=qspi_ffree_loc;
  qspi_led_qspi_loc=loc;
  /* SPCR0 defined bit count, SPCR1 defined delay after transfer
     and delay after PCS, TLC0838 connected to PCS1 */
  QSM_QSPICR[loc]=QSM_CONT*0|QSM_BITSE*1|QSM_DT*1|QSM_DSCK*1|
                  __val2mfld(QSM_PCS,pcs_mask);
  QSM_QSPITR[loc]=0x1234;
  loc++;

  qspi_ffree_loc=loc;
  *QSM_SPCR2=(*QSM_SPCR2&~QSM_ENDQP)|__val2mfld(QSM_ENDQP,loc-1);
  atomic_set_mask_w(QSM_SPE,QSM_SPCR1);
  return 0;
}

void qspi_led_set_val(int val)
{
  QSM_QSPITR[qspi_led_qspi_loc]=val;
}

int qspi_led_rdswitch()
{
  return QSM_QSPIRR[qspi_led_qspi_loc];
}

unsigned short statchk_counter=0;
unsigned short statchk_switches_last=0;
unsigned short statchk_switches=0;
unsigned short statchk_switches_change=0;
unsigned short statchk_power_stop=0;
unsigned short statchk_power_off=0;

void status_check_and_led()
{
  unsigned new_led_state;
  unsigned short switches;
  int error_flag=0;
  
  new_led_state=1*QSPI_LED_MSK_A;
		
  if(trap_pc_addr){
    if(statchk_counter&2) new_led_state|=QSPI_LED_MSK_ERR;
  }else{
    if(error_flag) new_led_state|=QSPI_LED_MSK_ERR;
  }

  switches=qspi_led_rdswitch();
			    
  qspi_led_set_val(new_led_state);
  
  statchk_counter++;
}

/*
 *-----------------------------------------------------------
 */

/* TPU tests */

int check_tstme(int flg)
{
  __u16 val1,val2,val3,old;
  __u16 cnt=0;
  old=*SIM_CREG;
  *SIM_CREG=0x201;
  val1=*SIM_CREG;
  do{
    val2=*SIM_CREG;
  }while((cnt=++cnt&0x1f)&&!(val2&1));
  if(flg&1){
    printf("Test TSTME pin state\n");
    printf("  CREG=0x%04X\n",old);
    printf("  CREG=0x%04X\n",val1);
    printf("  CREG=0x%04X after %d loops\n",val2,cnt);
  }
  if(!(flg&2))
  {
    *SIM_CREG=0x200;
    val3=*SIM_CREG;
    if(flg&1)printf("  CREG=0x%04X\n",val1);
  }
  return cnt;
}

/*
 *-----------------------------------------------------------
 */

/* selection of debug messages */

#define	DBGPF_AXES	0x00ff	/* mask for all axes */
#define	DBGPF_PER_TIME	0x0100	/* periodic time print */
#define	DBGPF_PER_CUR	0x0200	/* periodic motor current */
#define	DBGPF_PER_ADC	0x0400	/* periodic adc info */
#define	DBGPF_PER_POS	0x0800	/* periodic position info */
#define	DBGPF_CMD_PROC	0x1000	/* command proccessing */
#define	DBGPF_QSPI_LED	0x2000	/* leds on QSPI */
unsigned dbg_prt_flg=0;

typedef struct dbg_prt_des{
  unsigned mask;
  char *name;
}dbg_prt_des_t;

dbg_prt_des_t dbg_prt_des[]={
  {~0,"all"},
  {1,"A"},{2,"B"},{4,"C"},{8,"D"},
  {16,"E"},{32,"F"},{64,"G"},{128,"H"},
  {DBGPF_PER_TIME,"time"},
  {DBGPF_PER_CUR, "cur"},
  {DBGPF_PER_ADC, "adc"},
  {DBGPF_PER_POS, "pos"},
  {DBGPF_CMD_PROC,"cmd"},
  {DBGPF_QSPI_LED,"led"},
  {0,NULL}
};


int cmd_do_switches(cmd_io_t *cmd_io, const struct cmd_des *des, char *param[])
{
  unsigned val,*pval;
  long l;
  dbg_prt_des_t *pdes,*pd;
  char *ps;
  char str[20];
  char pm_flag;
  pval=(unsigned*)(des->info[0]);
  pdes=(dbg_prt_des_t*)(des->info[1]);
  ps=(des->mode&CDESM_OPCHR)?param[3]:param[1];
  val=*pval;
  if(*ps=='?'){
    while(pdes->name){
      printf(" %s",pdes->name);
      pdes++;
    }
    printf("\n");
  }
  while(*ps){
    si_skspace(&ps);
    if(!*ps) break;
    pm_flag=0;
    if(*ps=='+'){ps++;}
    else if(*ps=='-'){pm_flag=1;ps++;}
    else val=0;
    if(isdigit((__u8)*ps)){if(si_long(&ps,&l,0)<0) return -1;}
    else{
      si_alnumn(&ps,str,20);
      pd=pdes;
      do{
        if(!pd->name) return -1;
	if(!strcmp(pd->name,str)){
	  l=pd->mask; break;
	}
	pd++;
      }while(1);
    }
    if(pm_flag) val&=~l;
    else val|=l;
  }
  *pval=val;
  return 0;
}


int cmd_do_ioecho(cmd_io_t *cmd_io, const struct cmd_des *des, char *param[])
{
  int val;
  int opchar;

  if((opchar=cmd_opchar_check(cmd_io,des,param))<0) return opchar;
  if(opchar==':'){
    val=*param[3];
    if(val=='0')
      cmd_io->priv.ed_line.in->flg&=~FL_ELB_ECHO;
    else if(val=='1')
      cmd_io->priv.ed_line.in->flg|=FL_ELB_ECHO;
    else return -CMDERR_BADPAR;
  }else{
    cmd_io_write(cmd_io,param[0],param[2]-param[0]);
    cmd_io_putc(cmd_io,'=');
    cmd_io_putc(cmd_io,cmd_io->priv.ed_line.in->flg&FL_ELB_ECHO?'1':'0');
  }
  return 0;
}


int cmd_do_rs232baud(cmd_io_t *cmd_io, const struct cmd_des *des, char *param[])
{
  int val;
  if(*param[2]!=':') return -CMDERR_OPCHAR;
  val=atoi(param[3]);
  if(val<=2400) return -CMDERR_BADPAR;
  qsm_rs232_setmode(val,-1,-1);
  return 0;
}


const char software_ver[]="SIMPLE v0.5 build CVUT NMS "__DATE__" "__TIME__;

int cmd_do_ver(cmd_io_t *cmd_io, const struct cmd_des *des, char *param[])
{
  if(*param[2]!='?') return -CMDERR_OPCHAR;
  cmd_io_write(cmd_io,param[0],param[2]-param[0]);
  cmd_io_putc(cmd_io,'=');
  cmd_io_write(cmd_io,software_ver,strlen(software_ver));
  return 0;
}


int cmd_do_spmax(cmd_io_t *cmd_io, const struct cmd_des *des, char *param[])
{
  printf("spmax=%8d\n",ctm4_sfi_spmax);
  ctm4_sfi_spmax=0;
  return 0;
}


int cmd_do_date(cmd_io_t *cmd_io, const struct cmd_des *des, char *param[])
{
  /* for(i=0;param[i];i++) printf("param %d = \"%s\"\n",i,param[i]); */
  if(param[1]){
    strncpy(date,param[1],19);
    set_date();
  }
  get_date();
  printf("actual date is %s\n",date);
  return 0;
}


int cmd_do_syscpuhz(cmd_io_t *cmd_io, const struct cmd_des *des, char *param[])
{
  int new_sys_hz;
  if(param[1]&&*param[1]){
    new_sys_hz=atoi(param[1]);
    if((new_sys_hz<1000000)||(new_sys_hz>40000000))
      new_sys_hz=CPU_SYS_HZ;
    sim_init_pll(new_sys_hz);
    qsm_rs232_setmode(-1,-1,-1);
    can_hw_init(-1,-1);
  }
  printf("System clock is %d HZ\n",cpu_sys_hz);
  return 0;
}


extern int perftest(char *s);

int cmd_do_perftest(cmd_io_t *cmd_io, const struct cmd_des *des, char *param[])
{
  perftest(param[1]);
  return 0;
}


extern void dhry_main(void);
int cmd_do_dhrytest(cmd_io_t *cmd_io, const struct cmd_des *des, char *param[])
{
  dhry_main();
  return 0;
}


int cmd_do_cantest(cmd_io_t *cmd_io, const struct cmd_des *des, char *param[])
{
  can_hw_test(param[1]);
  return 0;
}


int cmd_do_check_tstme(cmd_io_t *cmd_io, const struct cmd_des *des, char *param[])
{
  check_tstme(1);
  return 0;
}


int cmd_do_errorshow(cmd_io_t *cmd_io, const struct cmd_des *des, char *param[])
{
  int ret;
  ret=trap_occ_show();
  if(!ret)
    cmd_io_write(cmd_io,"no error",8);
  return 0;
}


/* Select default flash algorithms to AMD29F400 */
/*flash_alg_info_t const *flash_alg_info=&amd_29f400_x16;*/

/* Select default flash algorithms to AMD29F800 */
flash_alg_info_t const *flash_alg_info=&amd_29f800_x16;

int cmd_do_flashid(cmd_io_t *cmd_io, const struct cmd_des *des, char *param[])
{
  __u32 addr;
  __u16 checkid[2];
  int ret;
  
  if(sscanf(param[1],"%i",&addr)!=1){
    printf("bad addres format\n");
    return 0;
  }
  ret=flash_check_id(flash_alg_info,(void*)addr,checkid);
  printf("flash_check_id returned %d, manid 0x%X devid 0x%X\n",
  		ret,checkid[0],checkid[1]);
  return 0;
}


int cmd_do_flashprog(cmd_io_t *cmd_io, const struct cmd_des *des, char *param[])
{
  __u32 addr;
  __u32 val;
  int ret;

  if(sscanf(param[1],"%i %i",&addr,&val)!=2){
    printf("bad addres or data format\n");
    return 0;
  }
  ret=flash_prog(flash_alg_info,(void*)addr,val);
  printf("flash_prog returned %d\n",ret);
  return 0;
}


int cmd_do_flasherase(cmd_io_t *cmd_io, const struct cmd_des *des, char *param[])
{
  __u32 addr;
  __u32 range;
  int ret;

  if(sscanf(param[1],"%i %i",&addr,&range)!=2){
    printf("bad addres or range format\n");
    return 0;
  }
  ret=flash_erase(flash_alg_info,(void*)addr,(__u16)range);
  printf("flash_erase returned %d\n",ret);
  return 0;
}


int cmd_do_flashtest(cmd_io_t *cmd_io, const struct cmd_des *des, char *param[])
{
  __u32 addr;
  int ret;
  __u8 *p;
  __u16 *pw;
  __u16 val;

  if(sscanf(param[1],"%i",&addr)!=1){
    addr=0x800000;
  }
  printf("Checking flash id at addr 0x%08x ... ",addr);
  ret=flash_check_id(flash_alg_info,(void*)addr,NULL);
  printf("%s\n",ret<0?"Error":"OK"); if(ret<0) return 0;
  printf("Flash erase ... ");
  fflush(stdout);
  ret=flash_erase(flash_alg_info,(void*)addr,0);
  printf("%s\n",ret<0?"Error":"OK"); if(ret<0) return 0;
  ret=0;
  for(p=(__u8*)addr;p<=(__u8*)addr+flash_alg_info->addr_mask;p++)
    if(*p!=0xff){
      if(ret<100)printf("Erase not blank at 0x%08lx data 0x%02x\n",
      			  (long)p,(int)*p);
      ret++;
    }
  if(ret) return 0;
  printf("Flash pattern program ");
  fflush(stdout);
  val=0;
  for(pw=(__u16*)addr;(__u8*)pw<=(__u8*)addr+flash_alg_info->addr_mask;pw++){
    ret=flash_prog(flash_alg_info,pw,val);
    val++;
    if(ret<0) break;
    if(!((long)pw&0x3fff)){
      printf("."); val++;
      fflush(stdout);
    }
  }
  if(ret<0){
    printf("\nProgram error at 0x%08lx code %d\n",(long)pw,ret);
    return 0;
  }
  printf(" OK\n");
  printf("Flash pattern verify ... ");
  fflush(stdout);
  val=0; ret=0;
  for(pw=(__u16*)addr;(__u8*)pw<=(__u8*)addr+flash_alg_info->addr_mask;pw++){
    if((*pw!=val)&&(ret<100)){
      printf("\nProgram verify error at 0x%08lx diff %d",(long)pw,*pw^val);
      ret++;
    }
    val++;
    if(!((long)pw&0x3fff)) val++;
  }
  if(ret) {printf(" Error\n");return 0;}
  printf(" OK\n");
  printf("All tests returned OK\n");
  return 0;
}

int cmd_do_gdbbreak(cmd_io_t *cmd_io, const struct cmd_des *des, char *param[])
{  
  int break_fl;
  if(sscanf(param[1],"%i",&break_fl)!=1){
    break_fl=2;
  }

  /* Decide if Ctrl+C is redirected to GDB stub */
  qsm_break2gdb=break_fl?1:0;
  /* Decide if RS232 dedicated for GDB debugging only */
  qsm_used4gdbonly=break_fl>=3;
  /* Prepare for load of new application */
  if(break_fl>=4) {
    *CTM4_MCSM2SIC&=~CTM4_MCSM_IL; /* Stop interrupts */
    *QSM_QILR&=~QSM_ILQSPI;
    *TPU_TICR&=~TPU_CIRL;
    /* interrupts of all other used modules should be stopped here */
    qsm_used4gdbdirect();
  }
  gdb_set_debug_traps(gdb_without_hooks);
  if(break_fl>=2)
    breakpoint();
  return 0;
}


/* communication flags and options */
cmd_des_t const cmd_des_stamp={0, CDESM_OPCHR,
			"STAMP","host communication stamp",
			cmd_do_stamp,{}};
cmd_des_t const cmd_des_echo={0, CDESM_OPCHR|CDESM_RW,
			"ECHO","enable echoing of received character",cmd_do_ioecho,{}};
cmd_des_t const cmd_des_rs232baud={0, CDESM_OPCHR|CDESM_WR,
			"RS232BAUD","communication baud rate",cmd_do_rs232baud,{}};
cmd_des_t const cmd_des_ver={0, CDESM_OPCHR|CDESM_RD,
			"VER","software version",cmd_do_ver,{}};
/* system debug and options */
cmd_des_t const cmd_des_dprint={0, 0,"dprint","enable debug messages to print, use + - to add remove, list types ?",
			cmd_do_switches,
			{(char*)&dbg_prt_flg,(char*)dbg_prt_des}};
cmd_des_t const cmd_des_spmax={0, 0,"spmax",0,cmd_do_spmax,{}};
cmd_des_t const cmd_des_cmd1={0, CDESM_OPCHR,"cmd1",0,NULL,{(char*)100,(char*)333}};
cmd_des_t const cmd_des_date={0, 0,"date",0,cmd_do_date,{}};
cmd_des_t const cmd_des_syscpuhz={0, 0,"syscpuhz",0,cmd_do_syscpuhz,{}};
cmd_des_t const cmd_des_perftest={0, 0,"perftest",0,cmd_do_perftest,{}};
cmd_des_t const cmd_des_dhrytest={0, 0,"dhry",0,cmd_do_dhrytest,{}};
cmd_des_t const cmd_des_cantest={0, 0,"can","CAN subcommands, try can ?",cmd_do_cantest,{}};
cmd_des_t const cmd_des_check_tstme={0, 0,"checktstme","pin TSTME ?",cmd_do_check_tstme,{}};
cmd_des_t const cmd_des_errorshow={0, 0,"errorshow","show captured errors",cmd_do_errorshow,{}};
cmd_des_t const cmd_des_flashid={0, 0,"flashid","check flash id at addr",cmd_do_flashid,{}};
cmd_des_t const cmd_des_flashprog={0, 0,"flashprog","flash prog value at addr",cmd_do_flashprog,{}};
cmd_des_t const cmd_des_flasherase={0, 0,"flasherase","check flash at addr erase",cmd_do_flasherase,{}};
cmd_des_t const cmd_des_flashtest={0, 0,"flashtest","test flash",cmd_do_flashtest,{}};
cmd_des_t const cmd_des_gdbbreak={0, 0,"gdbbreak","break and wait on RS232 for GDB",cmd_do_gdbbreak,{}};
cmd_des_t const cmd_des_help={0, 0,"help","prints help for commands",
			cmd_do_help,{(char*)&cmd_rs232}};

cmd_des_t const *cmd_rs232_default[]={
  &cmd_des_stamp,
  &cmd_des_echo,
  &cmd_des_rs232baud,
  &cmd_des_ver,
  &cmd_des_dprint,
  &cmd_des_spmax,
  &cmd_des_cmd1,
  &cmd_des_date,
  &cmd_des_syscpuhz,
  &cmd_des_perftest,
  &cmd_des_dhrytest,
  &cmd_des_cantest,
  &cmd_des_check_tstme,
  &cmd_des_errorshow,
  &cmd_des_flashid,
  &cmd_des_flashprog,
  &cmd_des_flasherase,
  &cmd_des_flashtest,
  &cmd_des_gdbbreak,
  &cmd_des_help,
  NULL
};

cmd_des_t const **cmd_rs232=cmd_rs232_default;

int cmd_rs232_enable_rec=1;
int cmd_rs232_generate=0;
unsigned long cmd_rs232_last_msec;
unsigned long cmd_rs232_idle_msec;
unsigned long last_status_check_msec;
unsigned long idlerel_time;


int cmd_rs232_processor_init()
{
  int val;  
  char s[30];

  qsm_rs232_sendstr("# ");
  qsm_rs232_sendstr(software_ver);
  qsm_rs232_sendstr("\r\n");

  /* Test TSTME pin state */
  if(check_tstme(0))
    qsm_rs232_sendstr("# test mode enabled\r\n");
  else
    qsm_rs232_sendstr("# test mode disabled\r\n");

  /* kl41 init */
  *KL41_LED_WR=0x7f;
  val=kl41_lcd_init();
  kl41_lcd_wrstr("I'm alive ");
  i2str(s,val,4,0);
  qsm_rs232_sendstr("# kl41_lcd_init : ");
  qsm_rs232_sendstr(s);
  qsm_rs232_sendstr("\r\n");
  
  /* RTC */
  /* set_date(); */
  get_date();
  last_status_check_msec=msec_time;
  cmd_rs232_last_msec=msec_time;
  cmd_rs232_idle_msec=msec_time;
  qsm_rs232_sendstr("# date : ");
  qsm_rs232_sendstr(date);
  qsm_rs232_sendstr("\r\n");

  cmd_io_rs232.priv.ed_line.in->inbuf=0;
  cmd_io_rs232.priv.ed_line.out->inbuf=0;

 #ifdef WITH_RS232_ECHO_OFF
  cmd_io_rs232.priv.ed_line.in->flg&=~FL_ELB_ECHO;
 #else /* WITH_RS232_ECHO_OFF */
  cmd_io_rs232.priv.ed_line.in->flg|=FL_ELB_ECHO;
 #endif /* WITH_RS232_ECHO_OFF */
  return 0;
}

int cmd_rs232_processor_run()
{
  int val;  
  static int cnt=0;
  int i;
  unsigned new_msec;
  int irc;
  char s[30];
  cmd_io_t* cmd_io;

  /* status checking and LED update */
  if((msec_time-last_status_check_msec)>250){
    last_status_check_msec+=250;
    status_check_and_led();   
  }

  cmd_io=&cmd_io_rs232;

  /* receive characters from serial line only when is not out pending */
  if(!cmd_rs232_line_out(cmd_io)&&cmd_rs232_enable_rec){
    if(cmd_rs232_line_in(cmd_io)>0){
      if(dbg_prt_flg&DBGPF_CMD_PROC)
        printf("ed_line_buf : %s\r\n",cmd_io->priv.ed_line.in->buf);
      if(cmd_rs232){
	val=proc_cmd_line(cmd_io, cmd_rs232, cmd_io->priv.ed_line.in->buf);
      }else{
	val=-CMDERR_BADCMD;
      }
      if(dbg_prt_flg&DBGPF_CMD_PROC)
        printf("proc_cmd_line returned %d\r\n",val);
      if(cmd_io->priv.ed_line.out->inbuf){
	cmd_io_putc(cmd_io,'\r');
	cmd_io_putc(cmd_io,'\n');
      }else if(val<0){
	char s[20];
	cmd_io_write(&cmd_io_rs232,"ERROR ",6);
	i2str(s,-val,0,0);
	cmd_io_write(cmd_io,s,strlen(s));
	cmd_io_putc(cmd_io,'\r');
	cmd_io_putc(cmd_io,'\n');
      }
      cmd_rs232_idle_msec=msec_time+idlerel_time*1000l;
    }
  }
  
  /* process pending output */
  if(cmd_io->priv.ed_line.out->inbuf){
    cmd_io_putc(cmd_io,'\r');
    cmd_io_putc(cmd_io,'\n');
    cmd_rs232_line_out(cmd_io);
  }


  if(cmd_rs232_generate)
  {
    val='0'+cnt++;
    if(cnt>9) cnt=0;
    while(qsm_rs232_sendch(val)<0);
  }

  new_msec=msec_time;
  if(new_msec-cmd_rs232_last_msec>2000)
  {
    cmd_rs232_last_msec+=2000;
    if(!cmd_io_rs232.priv.ed_line.in->lastch){

      if(dbg_prt_flg&DBGPF_PER_TIME){
        get_date();
        irc=tpu_irc_read(10);
        qsm_rs232_sendstr("date! ");
        qsm_rs232_sendstr(date);
        qsm_rs232_sendstr(" spmax");
        i2str(s,ctm4_sfi_spmax,6,0);
        qsm_rs232_sendstr(s);
        /* i2str(s,irc,6,0); */
        /* i2str(s,msec_time,8,3); */
        qsm_rs232_sendstr("\r\n");
      }
      
      if(dbg_prt_flg&DBGPF_PER_CUR){ /* ADC on SPI values */
	qsm_rs232_sendstr("cur!");
	for(i=0;i<8;i++){
	  qsm_rs232_sendstr(" ");
	  i2str(s,tlcadc_read(i),5,0);
	  qsm_rs232_sendstr(s);
	}
	qsm_rs232_sendstr("\r\n");
      }

      if(dbg_prt_flg&DBGPF_PER_ADC){ /* QADC values */
	qsm_rs232_sendstr("adc0!");
	for(i=0;i<18;i++){
	  if(i==8)qsm_rs232_sendstr("\r\nadc8!");
	  qsm_rs232_sendstr(" ");
	  i2str(s,QADC_RJURR[qadc_bq2+i],5,0);
	  qsm_rs232_sendstr(s);
	}
	qsm_rs232_sendstr("\r\n");
      }

      if(dbg_prt_flg&DBGPF_QSPI_LED){ /* SQPI LEDs and SWITCHes */
        sprintf(s,"led! send 0x%04X, rec 0x%04X\n\r",
		QSM_QSPITR[qspi_led_qspi_loc],
		QSM_QSPIRR[qspi_led_qspi_loc]);
	qsm_rs232_sendstr(s);
      }      
    }
    *KL41_LED_WR=(msec_time/2000)&0x7f;
    kl41_lcd_wrstr(".");
  }
  return 0;
}

void __main(void) {;};

int main()
{ unsigned flags=0;
  /* initialize PLL clock generator, cpu_ref_hz and cpu_sys_hz */
  sim_init();
 #ifndef GDBSTUB_RAM_TARGET
  /* clear GDB stub data area */
  gdb_clear_data_seg();
 #else /* GDBSTUB_RAM_TARGET */
  qsm_break2gdb=1;
 #endif /* GDBSTUB_RAM_TARGET */
  /* initialize RS232 communication interface */
  qsm_rs232_setmode(19200,QSM_RS232_MODEA,1);
  /* initialize fast timer and CTM4 PWM generators */
  msec_time=0;
  /* mode of hardware specific parts */
  ctm4_time_init();
  /* initialize TPU IRC counters */
  tpu_irc_init(10);
  /* start 16 chanel QADC conversion */
  qadc_init_16ch();
  /* initialize SPI subsystem */
  qspi_mode_init();
  tlcadc_init();
  
  qspi_led_init(); /* LED indicators at PCS2 non */

  /* initialize CAN subsystem */
  can_hw_init(-1,-1);
  
  /* *(int*)0xa00000=0; */

  /* force start of serial debugger and stop */
  if(0){
    qsm_break2gdb=1;
    gdb_set_debug_traps(gdb_without_hooks);
   #if 1
    breakpoint();
   #else
    /* check serial remote stub */
    __asm__ (
      "   movel %a6,%sp@-\n"
      "   movel #0x12345600,%d0\n"
      "   movel #0x23456711,%d1\n"
      "   movel #0x34567822,%d2\n"
      "   movel #0x45678933,%d3\n"
      "   movel #0x56789044,%d4\n"
      "   movel #0x67890155,%d5\n"
      "   movel #0x78901266,%d6\n"
      "   movel #0x89012377,%d7\n"
      "   movel #0x90123400,%a0\n"
      "   movel #0x01234511,%a1\n"
      "   movel #0x12345622,%a2\n"
      "   movel #0x23456733,%a3\n"
      "   movel #0x34567844,%a4\n"
      "   movel #0x45678955,%a5\n"
      "   movel #0x56789066,%a6\n"
      "   movew #0x20a5,%sr\n"
      "   /*trap  #1*/\n"	/* this one to check compiled break */
      "1: /*bra   1b*/\n"		/* this one to check ctrl+c */
      "   movel %sp@+,%a6\n"
    );
   #endif
  }

  save_flags(flags);
  flags&=~0x0700;
  restore_flags(flags);
  
  cmd_rs232_processor_init();
  do{
    cmd_rs232_processor_run();
  }while(1);
  return 0;
}

